/*  FIND PAYMENTS:                                                 */
/*                                                                 */
/*  Reads accounts lines one by one, writes overdue payments       */
/*  (containing the phrase PAYMENT OVERDUE) to an output file.     */

parse arg filein fileout                /* get 2 file names        */

do while lines(filein) > 0              /* do while a line to read */
  input_line = linein(filein)           /* read an input line      */
  if pos('PAYMENT OVERDUE',input_line) >= 1 then        /* $ Due?  */
     call lineout fileout,input_line    /* write line if $ overdue */
end

